import { BPTreeNode } from './base/BPTree';
import { SerializeStrategy, SerializeStrategyHead } from './base/SerializeStrategy';
import { Json } from './utils/types';
export declare abstract class SerializeStrategyAsync<K, V> extends SerializeStrategy<K, V> {
    abstract id(isLeaf: boolean): Promise<string>;
    abstract read(id: string): Promise<BPTreeNode<K, V>>;
    abstract write(id: string, node: BPTreeNode<K, V>): Promise<void>;
    abstract delete(id: string): Promise<void>;
    abstract readHead(): Promise<SerializeStrategyHead | null>;
    abstract writeHead(head: SerializeStrategyHead): Promise<void>;
    getHeadData(key: string, defaultValue: Json): Promise<Json>;
    setHeadData(key: string, data: Json): Promise<void>;
    autoIncrement(key: string, defaultValue: number): Promise<number>;
}
export declare class InMemoryStoreStrategyAsync<K, V> extends SerializeStrategyAsync<K, V> {
    protected readonly node: Record<string, BPTreeNode<K, V>>;
    constructor(order: number);
    id(isLeaf: boolean): Promise<string>;
    read(id: string): Promise<BPTreeNode<K, V>>;
    write(id: string, node: BPTreeNode<K, V>): Promise<void>;
    delete(id: string): Promise<void>;
    readHead(): Promise<SerializeStrategyHead | null>;
    writeHead(head: SerializeStrategyHead): Promise<void>;
}
