import { BPTreeNode } from './base/BPTree';
import { SerializeStrategy, SerializeStrategyHead } from './base/SerializeStrategy';
import { Json } from './utils/types';
export declare abstract class SerializeStrategySync<K, V> extends SerializeStrategy<K, V> {
    abstract id(isLeaf: boolean): string;
    abstract read(id: string): BPTreeNode<K, V>;
    abstract write(id: string, node: BPTreeNode<K, V>): void;
    abstract delete(id: string): void;
    abstract readHead(): SerializeStrategyHead | null;
    abstract writeHead(head: SerializeStrategyHead): void;
    getHeadData(key: string, defaultValue: Json): Json;
    setHeadData(key: string, data: Json): void;
    autoIncrement(key: string, defaultValue: number): number;
}
export declare class InMemoryStoreStrategySync<K, V> extends SerializeStrategySync<K, V> {
    protected readonly node: Record<string, BPTreeNode<K, V>>;
    constructor(order: number);
    id(isLeaf: boolean): string;
    read(id: string): BPTreeNode<K, V>;
    write(id: string, node: BPTreeNode<K, V>): void;
    delete(id: string): void;
    readHead(): SerializeStrategyHead | null;
    writeHead(head: SerializeStrategyHead): void;
}
